#include "SphereDEJ.h"
#include <cmath>


Sphere::Sphere(double x, double y, double z, double rad) {
    center[0] = x;
    center[1] = y;
    center[2] = z;
    radius = rad;
}
double Sphere::getX() {
    return center[0];
}
double Sphere::getY() {
    return center[1];
}
double Sphere::getZ() {
    return center[2];
}
double Sphere::getRadius() {
    return radius;
}
double Sphere::getVolume() {
    return 4.0/3.0 * M_PI * radius * radius * radius;
}
double Sphere::calculateMass(double density) {
    return density * getVolume();
}
bool Sphere::operator>(Sphere other) {
    return radius > other.radius;
}

std::ostream& operator<<(std::ostream& out, Sphere s) {
    out << "Sphere: center=(" << s.getX() << ", " << s.getY() << ", " << s.getZ() << "), radius=" << s.getRadius() << ", volume=" << s.getVolume();
    return out;
}
