#include "gtest/gtest.h"
#include "Sphere.h"
#include <iostream>
#include <string>
#include <vector>
#include <sstream>
#include <cmath>

using namespace std;

class Testing : public ::testing::Test {

protected:
    Testing() {}
    virtual ~Testing() {
    }

    virtual void SetUp() {}

    virtual void TearDown() {
	cout << endl << ":::END" << endl;
    }
};


TEST_F(Testing, testGetX) {
    cout << ":::NAME test getX" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,10);
    Sphere s2(12,14,16,18);
    cout << "Testing getX on a Sphere s(2,4,6,10)" << endl;
    EXPECT_DOUBLE_EQ(2, s.getX()) << "\n:::SCORE 0";
}

TEST_F(Testing, testGetY) {
    cout << ":::NAME test getY" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,10);
    Sphere s2(12,14,16,18);
    cout << "Testing getY on a Sphere s(2,4,6,10)" << endl;
    EXPECT_DOUBLE_EQ(4, s.getY()) << "\n:::SCORE 0";
}

TEST_F(Testing, testGetZ) {
    cout << ":::NAME test getZ" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,10);
    Sphere s2(12,14,16,18);
    cout << "Testing getZ on a Sphere s(2,4,6,10)" << endl;
    EXPECT_DOUBLE_EQ(6, s.getZ()) << "\n:::SCORE 0";
}

TEST_F(Testing, testGetRadius) {
    cout << ":::NAME test getRadius" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,10);
    Sphere s2(12,14,16,18);
    cout << "Testing getRadius on a Sphere s(2,4,6,10)" << endl;
    EXPECT_DOUBLE_EQ(10, s.getRadius()) << "\n:::SCORE 0";
}

TEST_F(Testing, testGetVolume) {
    cout << ":::NAME test getVolume" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,2);
    Sphere s2(12,14,16,10);
    cout << "Testing getVolume on a Sphere s(2,4,6,2)" << endl;

    EXPECT_DOUBLE_EQ((4.0/3.0)*M_PI*2.0*2.0*2.0, s.getVolume()) << "\n:::SCORE 0";
}

TEST_F(Testing, testCalculateMass) {
    cout << ":::NAME test calculateMass" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,2);
    Sphere s2(12,14,16,10);
    cout << "Testing calculateMass on a Sphere s(2,4,6,2) and density 3.0" << endl;

    EXPECT_DOUBLE_EQ((4.0/3.0)*M_PI*2.0*2.0*2.0* 3.0, s.calculateMass(3.0)) << "\n:::SCORE 0";
}

TEST_F(Testing, testOverload) {
    cout << ":::NAME test overloaded >" << endl;
    cout << ":::MAX_SCORE 5" << endl;
    cout << ":::SCORE 5" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,2);
    Sphere s2(12,14,16,10);
    cout << "Testing s(2,4,6,2) > s2(12,14,16,10)" << endl;

    EXPECT_TRUE( s2 > s) << "\n:::SCORE 0";
    EXPECT_FALSE( s > s2) << "\n:::SCORE 0";
}

TEST_F(Testing, testOutput) {
    cout << ":::NAME test overloaded <<" << endl;
    cout << ":::MAX_SCORE 4" << endl;
    cout << ":::SCORE 4" << endl;
    cout << ":::VISIBILITY after_published" << endl;

    Sphere s(2,4,6,2);
    Sphere s2(12,14,16,10);
    cout << "Testing cout << s(2,4,6,8)" << endl;
    stringstream ss;
    ss << s;
    string output = ss.str();

    EXPECT_TRUE( output.find("Sphere: center=") != string::npos) << "\n:::SCORE 0";
    EXPECT_TRUE( output.find(", radius=") != string::npos) << "\n:::SCORE 0";
    EXPECT_TRUE( output.find(", volume=") != string::npos) << "\n:::SCORE 0";
}

int main(int argc, char **argv) {
  testing::InitGoogleTest(&argc, argv);
  RUN_ALL_TESTS();
  return 0;
}
